        PAGE  ,132
;
;   This file contains interrupt service/appendage routines.
;
;
;
;
        TITLE    appends
;;
               %OUT  LARGE MODEL ASSEMBLY
;;
;;       Define the ARGUMENT BASE relative to BP
;;
               @AB      EQU       6

;;
;;       Define all of the C segments
;;
_TEXT          SEGMENT BYTE PUBLIC 'CODE'       ; Default code segment
_TEXT          ENDS
NULL           SEGMENT PARA PUBLIC 'BEGDATA'    ; Null pointer assignment check
NULL           ENDS
_DATA          SEGMENT WORD PUBLIC 'DATA'       ; Default data segment
_DATA          ENDS
CONST          SEGMENT WORD PUBLIC 'CONST'      ; Read only constants
CONST          ENDS
_BSS           SEGMENT WORD PUBLIC 'BSS'        ; Uninitialized static data
_BSS           ENDS
STACK          SEGMENT PARA STACK 'STACK'       ; Stack segment
STACK          ENDS
;;
DGROUP         GROUP   NULL,_DATA,CONST,_BSS,STACK
_TEXT          SEGMENT BYTE PUBLIC 'CODE'
               ASSUME    CS:_TEXT,DS:DGROUP
;;


SRVint       label dword
SRVint_off   dw  0
SRVint_seg   dw  0
RECint       label dword
RECint_off   dw  0
RECint_seg   dw  0
STAint       label dword
STAint_off   dw  0
STAint_seg   dw  0
;
DATA_seg     dw  0

;
; Message Services Interrupt handler
;
;       It passes control to the registered C function with the content
;       of AX register as argument. The C function should return a pointer
;       in DX:AX.
;
          PUBLIC _SrvApp
_SrvApp  PROC far


        push ds
        push ax                         ; use AX as argument for the C function

        mov  ax,cs:DATA_seg
        mov  ds,ax
        call SRVint                     ; invoke C function with argument AX
        add  sp,2                       ; remove argument

        pop  ds

        iret                            ; and exit the interrupt
_SrvApp  ENDP

; Received Data handler
;
;       It passes control to the registered C function with a pointer as
;       argument.
;
          PUBLIC _RecApp
_RecApp PROC far

        push ds
        push ax

        mov  ax,cs:DATA_seg
        mov  ds,ax
        pop  ax

        push es                         ; argument for C function
        push bx
        call RECint                     ; call C function with a pointer
        add  sp,4                       ; remove argument

        pop  ds

        iret                            ; and exit the interrupt
_RecApp ENDP

;
;
;
; status change handler
;
;       It passes control to the registerd C function with AX as argument.
;
          PUBLIC _StaApp
_StaApp  PROC far

        push ds
        push ax                         ; argument for C function

        mov  ax,cs:DATA_seg
        mov  ds,ax
        call STAint                     ; call C function with argument
        pop  ax                         ; remove argument

        pop  ds

        iret
_StaApp  ENDP                      ; and exit the interrupt

;
; Appendage initialization function
;
;       Accepts the addresses of the three C functions that the
;       interrupt service routine/appendages will execute when
;       the condition arises.
;
;       Returns nothing.
;

srvloc  =  @AB                          ; location on the stack
recloc  =  @AB+4
staloc  =  @AB+8

        PUBLIC  _appinit
_appinit PROC far

        push bp                         ; housekeeping
        mov  bp,sp
        push si
        push ds

        mov  ax,ds
        mov  cs:DATA_seg,ax

        lds  si,srvloc[bp]              ; save the address of CCBADDR
        mov  cs:SRVint_off,si
        mov  ax,ds
        mov  cs:SRVint_seg,ax
        lds  si,recloc[bp]              ; save the address of RECADDR
        mov  cs:RECint_off,si
        mov  ax,ds
        mov  cs:RECint_seg,ax
        lds  si,staloc[bp]              ; save the address of DLCADDR
        mov  cs:STAint_off,si
        mov  ax,ds
        mov  cs:STAint_seg,ax

        pop  ds                         ; housekeeping
        pop  si
        pop  bp
        
        ret                             ; and return
_appinit ENDP


_TEXT   ENDS
        end

