#ifndef __TRDIR
#define __TRDIR

#include "dlcptbls.h"
#include "dlcconst.h"
#include "trutl.h"

typedef struct {
        WORD station_id;
        WORD buffer_left;
	BYTE buffer_get;
        BYTE spare[3];
        BUFFER_PT *first_buffer;
        } BUFFER_FREE_PT;

typedef struct {
        BUFFER *buf_pointer;
        WORD rcv_len;
        WORD length_in_buffer;
        WORD user_offset;
        WORD user_length;
        BYTE rcvd_data[148];
        } RECV_BUFFER_TWO;

typedef struct {
	WORD dir_buf_size;
	WORD dir_pool_blocks;
	ADDRESS dir_pool_address;
	ADDRESS adpt_chk_exit;
	ADDRESS ring_status_exit;
	ADDRESS pc_error_exit;
	WORD open_options;
	} DIR_MODIFY_OPEN_PT;

typedef struct {
	WORD log_id;
	WORD log_buf_length;
	ADDRESS log_buf_addr;
	WORD log_act_length;
	} DIR_READ_LOG_PT;

typedef void (*FNPTR)(void);

BYTE dir_interrupt (CCB *ccbptr, BYTE adapternum);
BYTE dir_status (CCB *ccbptr, BYTE adapternum);
BYTE dir_initialize (CCB *ccbptr, BYTE adapternum);
BYTE dir_openadapter (CCB *ccbptr, BYTE adapternum, FNPTR StatApp);
BYTE dir_closeadapter (CCB *ccbptr, BYTE adapternum);
BYTE dir_timer_set (CCB *ccbptr, BYTE adapternum, int secs);
BYTE dir_timer_cancel (CCB *ccbptr, BYTE adapternum, ADDRESS timerccbptr);
BYTE dir_set_func_address(CCB *ccbptr, BYTE adapternum, DWORD func_addr);
BYTE dir_transmit(CCB *ccbptr, BYTE adapternum, WORD stationid,
	ADDRESS queue_one);
BYTE receive (CCB *ccbptr, BYTE adapternum, WORD stationid,
        FNPTR RecDataApp);
BYTE buffer_free (CCB *ccbptr, BYTE adapternum, WORD stationid,
        BUFFER_PT * bufferptr);
BYTE receive_cancel (CCB *ccbptr, BYTE adapternum, WORD stationid);
BYTE dir_modify_open_parms (CCB *ccbptr, BYTE adapternum, FNPTR StatApp);
BYTE dir_read_log(CCB *ccbptr, BYTE adapternum, BYTE *buffer, WORD bufsize);

#endif

