#ifndef __TRMSG
#define __TRMSG

//#include "trdir.h"
#ifndef DLCPTBLS

typedef unsigned char  BYTE;
typedef unsigned int   WORD;
typedef unsigned long  DWORD;
typedef unsigned char  *ADDRESS;

#endif 

#define SERVINT                 0x78

/* lower half to upper half messages */
#define MSG_HOUSEKEEPING        0
#define MSG_DATA_ERROR          1
#define MSG_DATA_INDICATION     2
#define MSG_DATA_BEACON         3
#define MSG_DATA_CONFIG         4

/* upper half to lower half messages */
#define MSG_REQUEST_MSG         5
#define MSG_REQUEST_RESET       6
#define MSG_REQUEST_REMOVE      7
#define MSG_REQUEST_ACTIVATE    8
#define MSG_REQUEST_INACTIVATE  9

#define MAXMSGS                 9

/* error return codes */
#define ERR_OK                  0
#define ERR_INVALID_MSG         1
#define ERR_FAILURE             2
#define ERR_NO_DATA             3

/* ring status constants */
#define STS_SIGNALLOSS          0x8000
#define STS_HARDERROR           0x4000
#define STS_SOFTERROR           0x2000
#define STS_XMITBEACON          0x1000
#define STS_WIREFAULT           0x0800
#define STS_REMOVAL1            0x0400
#define STS_REMOVERECVD         0x0100
#define STS_CNTOVERFLOWED       0x0080
#define STS_SINGLESTN           0x0040
#define STS_RECOVERY            0x0020

/* definition all all messages for communicating with the upper half */
typedef struct node{
	struct node *next;              //points to the next message
	ADDRESS buffer_one;             //DLC buffer address
	WORD msg;                       //message type
	BYTE retcode;                   //return code
	BYTE dir_retcode;               //direct interface return code
	BYTE more;                      //number of messages still queued
	BYTE beacontype;                //becaon type
	WORD ringstatus;                //ring status
	BYTE adapter[6];                //reporting adapter's address
	BYTE naun[6];                   //and its neighbour
	BYTE isoerr[5];                 //isolating error counts
	BYTE noniso[5];                 //non-isolating error counts
} Msgs;

#if __cplusplus
extern "C" {
#endif

int TRMsg(Msgs *msg);
void TRPrintMsg(Msgs *msg);

#if __cplusplus
}
#endif


#endif

